module Partoche.Utils where

import Euterpea

-- | Composition algorithmique

prefixes :: [a] -> [[a]]
prefixes [] = [[]]
prefixes (x:xs) = [x] : map f (prefixes xs)
  where
    f pf = x :pf

prefix :: Maybe (InstrumentName, InstrumentName) -> [Music a] -> Music a
prefix is mel = m :+: transpose 5 m :+: m
  where
    m1 = line (concat (prefixes mel))
    m2 = transpose 12 $ line $ concat $ prefixes $reverse mel
    m  = case is of
           Nothing -> m1 :=: m2
           Just (i1, i2) -> instrument i1 m1 :=: instrument i2 m2


-- | Canon
delayMusic :: Dur -> Music a -> Music a
delayMusic d m = rest d :+: m

replicateMusic :: Int -> Music a -> Music a
replicateMusic 0 m = rest 0
replicateMusic n m = m :+: replicateMusic (n - 1) m

repeatMusic :: Music a -> Music a
repeatMusic m = m :+: repeatMusic m




